import ConfigParser
import re
import fnmatch
import os
import commands
import subprocess
import shutil



class MovingProfiles:
	
	config_path="/net/etc/lliurex-moving/dirs.conf"
	
	
	def __init__(self):
		self.cfg=ConfigParser.SafeConfigParser()
		self.cfg.read([MovingProfiles.config_path])
	

		
	def isInclude(self,filename):
		#return re.match(self.include_regex,name)
		reti=[]
		for item in self.cfg.items("include"):
			name,value=item
			if fnmatch.fnmatchcase(filename,value):
				reti.append(name)
				
				
		if len(reti)==0:
			return None
		else:
			return reti
		
		
	def isExclude(self,filename):
		#return re.match(self.exclude_regex,name)
		rete=[]
		for item in self.cfg.items("exclude"):
			name,value=item
			if fnmatch.fnmatchcase(filename,value):
				rete.append(name)
				
		if len(rete)==0:
			return None
		else:
			return rete
	
	
	def Match(self,fname):
		
		include=False

		
		for item in self.cfg.items("include"):
			name,value=item
			if fnmatch.fnmatchcase(fname,value):
				include=True

				break
				
		if include:
			for item in self.cfg.items("exclude"):
				name,value=item
				if fnmatch.fnmatchcase(fname,value):

					return False
					
			return True
				
		else:
			return False
		
		"""
		im=re.match(self.include_regex,name)
		em=re.match(self.exclude_regex,name)
		
		if im and not em:
			return True
			
		return False
		"""
	
		
		
	def Save(self):
		with open(MovingProfiles.config_path, 'wb') as configfile:
			self.cfg.write(configfile)
		



	def GetProfilePath(self):
		try:
			
			user=os.getenv("USERNAME")
			groups=commands.getoutput("groups").split(" ")
			moving_profiles="/net/home/%s/%s/UserFiles/.moving_profiles/"%(groups[0],user)
		except:
			print "[MovingProfile] Failed constructing home path"
			raise
		

		return moving_profiles
		
		
		
	def LoadSession(self):
		moving_path=self.GetProfilePath()
		
		
		if not os.path.exists(moving_path):
			raise Exception("Profile dir not found, aborting load")
			
			
		print "[MovingProfile] Synchronization"
		home=os.path.expanduser("~")
		profile_files=os.listdir(moving_path)
		for fname in os.listdir(home):
			if self.Match(fname):
				if fname not in profile_files:
					print "* deleted " + fname
					if os.path.isdir(home+os.path.sep+fname):
						shutil.rmtree(home+os.path.sep+fname)
						
					if os.path.isfile(home+os.path.sep+fname):
						os.remove(home+os.path.sep+fname)

		subprocess.call(["rsync", "-rlptD",moving_path,home])
		
			
		
		
	def SaveSession(self):
		moving_path=self.GetProfilePath()
		print "[MovingProfile] moving path: "+moving_path
		
		if not os.path.exists(moving_path):
			print "[MovingProfile] Creating profile path"
			try:
				os.makedirs(moving_path)
			except:
				raise
				
				
		
		
		home=os.path.expanduser("~")
		print "[MovingProfile] Synchronization"
		print "[MovingProfile] Step 1"
		
		for fname in os.listdir(home):
			if self.Match(fname):
				if os.path.isfile(home+os.path.sep+fname):
					print "[rsync] file "+fname
					subprocess.call(["rsync","-av","--delete",home+os.path.sep+fname,moving_path])
				if os .path.isdir(home+os.path.sep+fname):
					print "[rsync] dir "+fname
					subprocess.call(["rsync","-av","--delete",home+os.path.sep+fname+os.path.sep,moving_path+os.path.sep+fname+os.path.sep])
			
			
		print "[MovingProfile] Step 2"
		home_files=os.listdir(home)
		for fname in os.listdir(moving_path):
			if not fname in home_files:
				if os.path.isdir(moving_path+os.path.sep+fname):
					print "* delete "+fname
					shutil.rmtree(moving_path+os.path.sep+fname)
				if os.path.isfile(moving_path+os.path.sep+fname):
					print "* delete "+fname
					os.remove(moving_path+os.path.sep+fname)

